package jp.ac.takushoku_u.cs;

/**
* TaskSequenceNX͊wKۑn񉻖@s߂̃NXłB
* @version 1.0
* @author } Tj(Kasajima Hiroshi)
*/
/*
* ŏIXV 2004N1104
*/
public class TaskSequence{
	
	private Matrix matrix;
	
	private static final int TASK_SEQUENCE_MATRIX_SIZE = 5;
	
/**
* ftHgŐݒ肳ĂlŌn񉻂sאڃ}gNXݒ肵܂B
*/
	public TaskSequence(){
		matrix = new Matrix(TASK_SEQUENCE_MATRIX_SIZE, TASK_SEQUENCE_MATRIX_SIZE);
	}
	
/**
* n񉻂sאڃ}gNXݒ肵܂B
* @param adjacencyMatrix אڃ}gNX
*/
	public TaskSequence(Matrix adjacencyMatrix){
		matrix = new Matrix(adjacencyMatrix.getRowLength(), adjacencyMatrix.getColLength());
		setMatrix(adjacencyMatrix);
	}
	
/**
* B}gNX߂B
* @return B}gNX
*/
	public Matrix getReachMatrix(){
		return getReachMatrix(matrix);
	}
	
/**
* אڃ}gNXB}gNX߂B
* @param adjacencyMatrix אڃ}gNX
* @return B}gNX
*/
	private Matrix getReachMatrix(Matrix adjacencyMatrix){
		Matrix returnMatrix = new Matrix(adjacencyMatrix.getRowLength(),
			adjacencyMatrix.getColLength(), adjacencyMatrix.getRowNameArray(), adjacencyMatrix.getColNameArray());
		return adjacencyMatrix.getReachMatrix();
	}
	
/**
* O񐫃}gNX߂B
* @return O񐫃}gNX
*/
	public Matrix getFMatrix(){
		Matrix reachMatrix = new Matrix(matrix.getRowLength(), matrix.getColLength(),
			matrix.getRowNameArray(), matrix.getColNameArray());
		reachMatrix.MatrixCopy(getReachMatrix(matrix));
		
		return getFMatrix(reachMatrix);
	}
	
/**
* B}gNX獇O񐫃}gNX߂B
* @param B}gNX
* @return O񐫃}gNX
*/
	private Matrix getFMatrix(Matrix reachMatrix){
		Matrix returnMatrix = new Matrix(reachMatrix.getRowLength(), reachMatrix.getColLength(),
			reachMatrix.getRowNameArray(), reachMatrix.getColNameArray());
		Matrix TMatrix = new Matrix(reachMatrix.getRowLength(), reachMatrix.getColLength(),
			reachMatrix.getRowNameArray(), reachMatrix.getColNameArray());
		
		TMatrix.MatrixCopy(reachMatrix.getTransposedMatrix());
		returnMatrix.MatrixCopy(TMatrix.getMultiplyMatrix(reachMatrix));
		return returnMatrix;
	}
	
/**
* ڕW}gNX߂B
* @return ڕW}gNX
*/
	public Matrix getGMatrix(){
		Matrix reachMatrix = new Matrix(matrix.getRowLength(), matrix.getColLength(),
			matrix.getRowNameArray(), matrix.getColNameArray());
		reachMatrix.MatrixCopy(getReachMatrix(matrix));
		
		return getGMatrix(reachMatrix);
	}
	
/**
* B}gNX獇ڕW}gNX߂B
* @param B}gNX
* @return ڕW}gNX
*/
	private Matrix getGMatrix(Matrix reachMatrix){
		Matrix returnMatrix = new Matrix(reachMatrix.getRowLength(), reachMatrix.getColLength(),
			reachMatrix.getRowNameArray(), reachMatrix.getColNameArray());
		Matrix TMatrix = new Matrix(reachMatrix.getRowLength(), reachMatrix.getColLength(),
			reachMatrix.getRowNameArray(), reachMatrix.getColNameArray());
		
		TMatrix.MatrixCopy(reachMatrix.getTransposedMatrix());
		returnMatrix.MatrixCopy(reachMatrix.getMultiplyMatrix(TMatrix));
		return returnMatrix;
	}
	
/**
* Rq[X}gNX߂B
* Rq[X}gNX́AO񐫃}gNX + ڕW}gNXłB
* @return Rq[X}gNX
* 
*/
	public Matrix getCoherentMatrix(){
		Matrix FMatrix = new Matrix(matrix.getRowLength(), matrix.getColLength(),
			matrix.getRowNameArray(), matrix.getColNameArray());
		Matrix GMatrix = new Matrix(matrix.getRowLength(), matrix.getColLength(),
			matrix.getRowNameArray(), matrix.getColNameArray());
		FMatrix.MatrixCopy(getFMatrix());
		GMatrix.MatrixCopy(getGMatrix());
		return getCoherentMatrix(FMatrix, GMatrix);
	}
	
/**
* O񐫃}gNXƍڕW}gNXRq[X}gNX߂B
* Rq[X}gNX́AO񐫃}gNX + ڕW}gNXłB
* @param FMatrix O񐫃}gNX
* @param GMatrix ڕW}gNX
* @return Rq[X}gNX
* 
*/
	private Matrix getCoherentMatrix(Matrix FMatrix, Matrix GMatrix){
		return FMatrix.getAddMatrix(GMatrix);
	}
	
/**
* אڃ}gNXݒ肷B
* @param m ݒ肷אڃ}gNX
*/
	public void setMatrix(Matrix m){
		matrix.MatrixCopy(m);
	}
}